#ifndef __LCP_H
#define __LCP_H

#include <algorithm>

void phi_lcp(unsigned char *X, int length, int *SA, int *LCP, int *temp) {
  int *PHI = LCP, *PLCP = temp;
  
  PHI[SA[0]] = -1;
  for (int i = 1; i < length; ++i)
    PHI[SA[i]] = SA[i-1];

  for (int i = 0, l = 0; i < length; ++i) {
    int j = PHI[i];
    if (j == -1) { PLCP[i] = 0; continue; }
    else {
      while (i + l < length && j + l < length && X[i + l] == X[j + l]) ++l;
      PLCP[i] = l;
      l = std::max(l - 1, 0);
    }
  }
  
  for (int i = 0; i < length; ++i)
    LCP[i] = PLCP[SA[i]];
}

#endif // __LCP_H
