#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <stdint.h>

#include "parse.h"
#include "utils.h"

int main(int argc, char **argv) {
  if (argc != 3 && argc != 4) {
    fprintf(stderr,"usage: %s <infile> <mem> [<outfile>]\n\n"
                   "Computes LZ-factorization of <infile> using <mem>MiB\n"
                   "of RAM and writes to <outfile> (if provided).\n",
                   argv[0]);
    std::exit(EXIT_FAILURE);
  }

  long max_block_size = (atoi(argv[2]) * (1L << 20)) / 29L;

  fprintf(stderr, "Command line = ");
  for (int i = 0; i < argc; ++i)
    fprintf(stderr, "%s ", argv[i]);
  fprintf(stderr, "\n");

  fprintf(stderr, "Filename = %s\n", argv[1]);
  fprintf(stderr, "Max block size = %ld\n",
      max_block_size);

  std::string in_fname = argv[1];
  std::string out_fname;
  if (argc == 4)
    out_fname = std::string(argv[3]);

  parse(in_fname, out_fname, max_block_size);
}

